
import java.util.*;
import java.io.*;

public class redblacktree_font
{
   public static void main(String[] args) throws Exception
   {
      PrintWriter out = new PrintWriter(System.out);
      new redblacktree_font(new FastScanner(System.in), out);
      out.close();
   }

   int N, K, MODO = 1_000_000_007;
   int preCount;
   int[] id, pre, next;
   ArrayList<Integer>[] adj;
   void dfs(int i, int p)
   {
      pre[i] = preCount++;
      id[pre[i]] = i;

      for (int j : adj[i]) if (j != p)
         dfs(j, i);

      next[i] = preCount;
   }

   public redblacktree_font(FastScanner in, PrintWriter out)
   {
      N = in.nextInt();
      K = in.nextInt();
      adj = new ArrayList[N];
      for (int i=0; i<N; i++)
         adj[i] = new ArrayList<>();
     
      for (int j=1; j<N; j++)
      {
         int i = in.nextInt()-1;
         adj[i].add(j);
      }

      boolean[] isRed = new boolean[N];
      for (int i=0; i<K; i++)
         isRed[in.nextInt()-1] = true;

      preCount = 0;
      id = new int[N];
      pre = new int[N];
      next = new int[N];
      dfs(0, 0);

      int[] curLevel = new int[N+1];
      int[] nxtLevel = new int[N+1];
      curLevel[0] = 1;
      for (int k=0; k<=K; k++)
      {
         // Take any number of black nodes (with same number of red).
         for (int i=0; i<N; i++)
         {
            int cur = id[i];
            curLevel[i+1] += curLevel[i];
            curLevel[i+1] %= MODO;
            
            if (!isRed[cur])
            {
               int nxt = next[cur];
               curLevel[nxt] += curLevel[i];
               curLevel[nxt] %= MODO;
            }
         }
        
         // This means we can print the answer
         out.println(curLevel[N]);

         // Take a single red node
         Arrays.fill(nxtLevel, 0);
         for (int i=N-1; i>=0; i--)
         {
            int cur = id[i];
            if (isRed[cur])
            {
               int nxt = next[cur];
               nxtLevel[nxt] += curLevel[i];
               nxtLevel[nxt] %= MODO;
            }
         }

         for (int i=0; i<=N; i++)
            curLevel[i] = nxtLevel[i];
      }
   }
}

class FastScanner{
    private InputStream stream;
    private byte[] buf = new byte[1024];
    private int curChar;
    private int numChars;
    
    public FastScanner(InputStream stream)
    {
        this.stream = stream;
    }
    
    int read()
    {
        if (numChars == -1)
            throw new InputMismatchException();
        if (curChar >= numChars){
            curChar = 0;
            try{
                numChars = stream.read(buf);
            } catch (IOException e) {
                throw new InputMismatchException();
            }
            if (numChars <= 0)
                return -1;
        }
        return buf[curChar++];
    }
    
    boolean isSpaceChar(int c)
    {
        return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
    }
    
    boolean isEndline(int c)
    {
        return c=='\n'||c=='\r'||c==-1;
    }
    
    int nextInt()
    {
        return Integer.parseInt(next());
    }
    
    long nextLong()
    {
        return Long.parseLong(next());
    }
    
    double nextDouble()
    {
        return Double.parseDouble(next());
    }
    
    String next(){
        int c = read();
        while (isSpaceChar(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do{
            res.appendCodePoint(c);
            c = read();
        }while(!isSpaceChar(c));
        return res.toString();
    }
    
    String nextLine(){
        int c = read();
        while (isEndline(c))
            c = read();
        StringBuilder res = new StringBuilder();
        do{
            res.appendCodePoint(c);
            c = read();
        }while(!isEndline(c));
        return res.toString();
    }
}
